/* 
   Copyright 1994-2003 Free Software Foundation, Inc.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
   USA

   You may contact the author at:

   mailto::camille@bluegrass.net

   or by snail mail at:

   David Lindauer
   850 Washburn Ave Apt 99
   Louisville, KY 40222
*/
#include <io.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <wchar.h>
#include <locale.h>
#include "libp.h"

extern int __uihandles[HANDLE_MAX], __uimodes[HANDLE_MAX], __uiflags[HANDLE_MAX] ;
extern char __uinames[HANDLE_MAX][256] ;

int _RTL_FUNC dup(int __handle)
{
   int h ; 
   int i,ohand = __handle ;
   __ll_enter_critical() ;
   h = __uinewhandpos() ;
   if (h == -1) {
      __ll_exit_critical() ;
      return h ;
   }
   __handle = __uiohandle(__handle) ;
   if (__handle == -1) {
      __ll_exit_critical() ;
      return __handle ;
   }
   i = __ll_dup(__handle) ;
   if (i == 0) {
      __ll_exit_critical() ;
      return -1 ;
   }
   __uimodes[h] = __uimodes[ohand] ;
   __uihandles[h] = i ;
   __uiflags[h] = __uiflags[ohand] ;
   strcpy(__uinames[h],__uinames[ohand]) ;
   __ll_exit_critical() ;
   return h ;
}
int _RTL_FUNC _dup(int __handle)
{
	return dup(__handle);
}